App.controller('summary', ['$scope', function ($scope) {

    var _this = this;
    _this.test = {
        Message: 'device.test', Command: "", DataType: "ASCII", IP: "", Port: ""
    }

    jnrwebsocket.addOnLoggedInListener(function onLoggedIn() {
        console.log("macro on load called")
        _this.config = {
            macros: []
        }
        _this.cinemaVersion;
        _this.cinemaDescription;
        _this.portNumber;
        _this.serialPort;
        _this.serialPortType;
        _this.runCinema = false;
        _this.savedConfig;
        jnrwebsocket.postMessage(2000, {Message: 'summary.get'});
        /**jnrwebsocket.registrySubscription('AppData/Cinema/CinemaServerClient/TcpPort', function (registryKey, registryValue) {
            _this.portNumber = registryValue;
        });*/
        jnrwebsocket.readRegistryKey('AppData/Cinema/CinemaServerClient/Method', function (registryKey, registryValue) {
            _this.serialPort = registryValue;
        });
        /**jnrwebsocket.registrySubscription('AppData/Cinema/CinemaServerClient/Serial/SerialPort', function (registryKey, registryValue) {
            _this.serialPortType = registryValue;
        });*/
        jnrwebsocket.readRegistryKey('run/cinema', function (registryKey, registryValue) {
            if (registryValue == "flash/cinema.jar") {
                _this.runCinema = true
            }
            if (registryValue == null) {
                _this.runCinema = false
            }
            _this.savedConfig = _this.runCinema;
        });
        jnrwebsocket.readRegistryKey('Applications/Cinema/Name', function (registryKey, registryValue) {
            _this.cinemaVersion = registryValue;
        });
        jnrwebsocket.readRegistryKey('Applications/Cinema/Desc', function (registryKey, registryValue) {
            _this.cinemaDescription = registryValue;
        });
        var msg = { Message: 'macro.list' };
        jnrwebsocket.addOnReplyMessageListener(function (data_json) {
            if (data_json.Message == 'macro.list.response') {
                _this.config.macros.length = 0;
                for (var index in data_json.MacroNames) {
                    _this.config.macros.push(data_json.MacroNames[index]);
                }
                $scope.$apply();
            }
            console.log('This is the data_json.Summary object: ' + JSON.stringify(data_json));
            console.log('This is the data_json.Summary object: ' + JSON.stringify(data_json.Summary));
            console.log(data_json);
            //console.log(data_json.Summary.CinemaServerClient.Port);
            if (data_json.Message == 'summary.response') {
                _this.portNumber = data_json.Summary.CinemaServerClient.Port;
                _this.serialPortType = data_json.Summary.CinemaServerClient.SerialPort;
                if (_this.serialPortType == null) {
                    _this.serialPortType = "none";
                }
            }
        })
        jnrwebsocket.postMessage(2000, msg);
    });

    _this.execute = function (macros) {
        var obj = {Message: 'macro.execute', MacroName: macros};
        jnrwebsocket.postMessage(2000, obj);
    }

    _this.testDevice = function (test) {
        jnrwebsocket.postMessage(2000, test);
    }

    _this.hasChanged = function (runCinema, savedConfig) {
        var hasChanged = !angular.equals(runCinema, savedConfig);
        return hasChanged;
    };

    _this.emptyTestCheck = function (test) {
        var isEmpty = false;
        if (test.Command == "" || null) {
            isEmpty = true;
            return isEmpty;
        }
        if (test.DataType == "" || null) {
            isEmpty = true;
            return isEmpty;
        }
        if (test.IP == "" || null) {
            isEmpty = true;
            return isEmpty;
        }
        if (test.Port == "" || null) {
            isEmpty = true;
            return isEmpty;
        }
        return isEmpty;
    };

    _this.writingRegistry = function () {
        if (_this.runCinema) {
            jnrwebsocket.registryWrite('run/cinema', "flash/cinema.jar");
        } else {
            jnrwebsocket.registryWrite('run/cinema', "");
        }
        alert("Configuration Saved. A reboot WILL be needed for this change to take effect.");
    }

}]);
